{-# LANGUAGE TemplateHaskell, QuasiQuotes, TypeFamilies, ViewPatterns, OverloadedStrings #-}

module Web.Informative.Data where

import Data.Text
import Yesod

data Informative = Informative { getSegment :: Text, getPrefix :: Text }

mkYesodSubData "Informative" [parseRoutes|
 /article/#Text ArticleR GET
 /articleid/#Int ArticleIdR GET
 /edit/#Int EditR GET POST
 /insert/#Int InsertR GET POST
 /prepend/#Int PrependR GET POST
 /down/#Int DownR POST
 /up/#Int UpR POST
 /delete/#Int DeleteR POST
 /create/#Text CreateR GET POST
|]

data TextFormat = Markdown | MediaWiki | ReStructuredText | LaTeX | Textile | Source Text Int | Plain deriving (Eq,Ord,Show,Read)
derivePersistField "TextFormat"

data TextKind = Article | Table | Mapping | Hint | Error deriving (Eq, Ord, Show, Read, Enum, Bounded)
derivePersistField "TextKind"
